﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Mail;
using System.IO;
using System.Threading;


namespace CLAS
{
    public partial class Form1 : Form
    {
        bool sem;
        bool cnaa;

        string path = @"CLASsettings.txt";
        string html;
        string[] TempItem = new string[3];

        int KeywordSize;
        int CountySize;
        int ItemSize;
        int offSet = 3;

        string[] keyword = new string[14]; // array for keywords to be found in items
        string[] county = new string[14]; // array of counties
        string[] item = new string[42]; // array of items from every county (3 in each county)
        string[] dcheck = new string[14]; // used to check to not send notification twice
        
        public Form1()
        {
            InitializeComponent();
            button7.Hide();
            Loader();
        }
        ~Form1()
        {
            Save();
        }
        public void GetHTML(string address)
        {
            AddText("scanning: " + address + "\n\n");
            try
            {
                HttpWebRequest req = (HttpWebRequest)WebRequest.Create(address);
                HttpWebResponse resp = (HttpWebResponse)req.GetResponse();

                Stream strm = resp.GetResponseStream();
                StreamReader rdr = new StreamReader(strm);

                html = rdr.ReadToEnd();

                resp.Close();

                html = html.ToUpper();
                cnaa = false;
            }
            catch
            {
                AddRedText(" - could not access: " + address + " - \n\n");
                cnaa = true;
            }
        }
        public void Extract3ItemsFromHTML()
        {
            // using .HTML and </a> as delemitors
            int i;
            TempItem[0] = html.Remove(0, FindPosition(html, ".HTML") + 7);
            for (i = 0; i<=offSet; i++)
                TempItem[0] = TempItem[0].Remove(0, FindPosition(TempItem[0], ".HTML") + 7);
            TempItem[0] = TempItem[0].Remove(FindPosition(TempItem[0], "</A>"), TempItem[0].Length - FindPosition(TempItem[0], "</A>"));

            TempItem[1] = html.Remove(0, FindPosition(html, ".HTML") + 7);
            for (i = 0; i <= offSet + 1; i++)
                TempItem[1] = TempItem[1].Remove(0, FindPosition(TempItem[1], ".HTML") + 7);
            TempItem[1] = TempItem[1].Remove(FindPosition(TempItem[1], "</A>"), TempItem[1].Length - FindPosition(TempItem[1], "</A>"));

            TempItem[2] = html.Remove(0, FindPosition(html, ".HTML") + 7);
            for (i = 0; i <= offSet + 2; i++)
                TempItem[2] = TempItem[2].Remove(0, FindPosition(TempItem[2], ".HTML") + 7);
            TempItem[2] = TempItem[2].Remove(FindPosition(TempItem[2], "</A>"), TempItem[2].Length - FindPosition(TempItem[2], "</A>"));
        }
        public void GetItems()
        {
            int TempCount = 0;
            ItemSize = 0;

            GetCounties();

            for (int i = 0; i < CountySize; i++)
            {
                GetHTML(county[i]);
                if (cnaa)
                    continue;
                Extract3ItemsFromHTML();

                for (int j = 0; j < 3; j++)
                {
                    item[ItemSize] = TempItem[TempCount];
                    AddText(" item " + (j + 1) + " from " + county[i] + ":\n" + item[ItemSize] + "\n\n");
                    ItemSize++;
                    TempCount++;
                }
                TempCount = 0;
            }
        }
        public void SendNotification(string message)
        {
            AddText("\nsending notification...\n");
            try
            {
                SmtpClient smtp = new SmtpClient(textBox31.Text, Convert.ToInt32(textBox32.Text));

                smtp.UseDefaultCredentials = false;
                smtp.Credentials = new System.Net.NetworkCredential(textBox29.Text, textBox30.Text);
                smtp.EnableSsl = true;

                smtp.Send(textBox29.Text, textBox33.Text, "Craigslist Alert", message);

                AddText("\n - notification sent - \n");
            }
            catch
            {
                AddRedText("\n - notification failed to send - \n");
            }
            notifyIcon1.BalloonTipText = message;
            notifyIcon1.ShowBalloonTip(5000);
        }
        public void Scan()
        {
            bool flag;
            int k;
            int l;

            while(sem)
            {
                ReplaceText("scanning.");
                Thread.Sleep(1000);
                AddText(".");
                Thread.Sleep(1000);
                AddText(".");
                Thread.Sleep(1000);
                ReplaceText("");
                flag = false;
                GetKeywords();
                GetItems();
                for (int i = 0; i < KeywordSize; i++)
                {
                    for (int j = 0; j < ItemSize; j++)
                    {
                        k = ((j / 3) * 3); // (j/3) gives the county number the item is in, * 3 insures to go to first item on list.
                        if (CheckItem(item[j], keyword[i]))
                        {
                            if (item[k] != dcheck[j / 3]) // when the keyword has not already been found in any of the 3 items of that county, send notification
                                if (item[k + 1] != dcheck[j / 3])
                                    if (item[k + 2] != dcheck[j / 3])
                                    {
                                        AddGreenText(" - item found in: " + county[j / 3] + " - \n");
                                        SendNotification(item[j] + "\n category: " + county[j / 3] + "\n\n first three items: \n" + item[k] + "\n\n" + item[k+1] + "\n\n" + item[k+2]);
                                        flag = true;
                                        dcheck[j / 3] = item[j]; // only 1 keyword will be found in the first 3 items, the others ignored if there, because the user would see them anyway.
                                    }
                        }
                        else // when the already found keyword is not found in any of the 3 items of that county, dcheck will clear
                        {
                            if (item[k] != dcheck[j / 3])
                                if (item[k + 1] != dcheck[j / 3])
                                    if (item[k + 2] != dcheck[j / 3])
                                        dcheck[j / 3] = "eemmppttyy";
                        }
                    }
                }
                if(!flag)
                    AddText(" - no keywords found in current items - \n");
                Thread.Sleep(7000);
            }
            HideB();
        }
        public int FindPosition(string s, string keyword)
        {
            int true_count = 0;
            int keyword_count = 0;

            for (int i = 0; i < s.Length; i++)
            {
                if (s[i] == keyword[keyword_count])
                {
                    for (int j = i; j <= i + keyword.Length; j++)
                    {
                        if (j >= s.Length)
                            break;
                        if (s[j] == keyword[keyword_count])
                            true_count++;
                        keyword_count++;
                        if (keyword_count >= keyword.Length)
                            break;
                    }
                    if (true_count >= keyword.Length)
                        return i;
                    keyword_count = 0;
                    true_count = 0;
                }
            }
            return 0;
        }
        public bool CheckItem(string line, string keyword)
        {
	        int true_count = 0;
	        int keyword_count = 0;

            line = line.ToUpper();
            keyword = keyword.ToUpper();

	        for(int i=0; i < line.Length; i++)
	        {
		        if(line[i]==keyword[keyword_count])
		        {
			        for(int j=i; j<=i+keyword.Length; j++)
			        {
                        if (j >= line.Length)
                            break;
				        if(line[j]==keyword[keyword_count])
					        true_count++;
				        keyword_count++;
                        if (keyword_count >= keyword.Length)
                            break;
			        }
			        if(true_count>=keyword.Length)
				        return true;
			        keyword_count = 0;
			        true_count = 0;
		        }
	        }
	        return false;
        }
        public int GetKeywords()
        {
            KeywordSize = 0;

            if (textBox1.Text.Length > 1)
            {
                keyword[KeywordSize] = textBox1.Text;
                KeywordSize++;
            }
            if (textBox2.Text.Length > 1)
            {
                keyword[KeywordSize] = textBox2.Text;
                KeywordSize++;
            }
            if (textBox3.Text.Length > 1)
            {
                keyword[KeywordSize] = textBox3.Text;
                KeywordSize++;
            }
            if (textBox4.Text.Length > 1)
            {
                keyword[KeywordSize] = textBox4.Text;
                KeywordSize++;
            }
            if (textBox5.Text.Length > 1)
            {
                keyword[KeywordSize] = textBox5.Text;
                KeywordSize++;
            }
            if (textBox6.Text.Length > 1)
            {
                keyword[KeywordSize] = textBox6.Text;
                KeywordSize++;
            }
            if (textBox7.Text.Length > 1)
            {
                keyword[KeywordSize] = textBox7.Text;
                KeywordSize++;
            }
            if (textBox8.Text.Length > 1)
            {
                keyword[KeywordSize] = textBox8.Text;
                KeywordSize++;
            }
            if (textBox9.Text.Length > 1)
            {
                keyword[KeywordSize] = textBox9.Text;
                KeywordSize++;
            }
            if (textBox10.Text.Length > 1)
            {
                keyword[KeywordSize] = textBox10.Text;
                KeywordSize++;
            }
            if (textBox11.Text.Length > 1)
            {
                keyword[KeywordSize] = textBox11.Text;
                KeywordSize++;
            }
            if (textBox12.Text.Length > 1)
            {
                keyword[KeywordSize] = textBox12.Text;
                KeywordSize++;
            }
            if (textBox13.Text.Length > 1)
            {
                keyword[KeywordSize] = textBox13.Text;
                KeywordSize++;
            }
            if (textBox14.Text.Length > 1)
            {
                keyword[KeywordSize] = textBox14.Text;
                KeywordSize++;
            }
            return KeywordSize;
        }
        public int GetCounties()
        {
            CountySize = 0;

            if (textBox15.Text.Length > 7)
            {
                county[CountySize] = textBox15.Text;
                CountySize++;
            }
            if (textBox16.Text.Length > 7)
            {
                county[CountySize] = textBox16.Text;
                CountySize++;
            }
            if (textBox17.Text.Length > 7)
            {
                county[CountySize] = textBox17.Text;
                CountySize++;
            }
            if (textBox18.Text.Length > 7)
            {
                county[CountySize] = textBox18.Text;
                CountySize++;
            }
            if (textBox19.Text.Length > 7)
            {
                county[CountySize] = textBox19.Text;
                CountySize++;
            }
            if (textBox20.Text.Length > 7)
            {
                county[CountySize] = textBox20.Text;
                CountySize++;
            }
            if (textBox21.Text.Length > 7)
            {
                county[CountySize] = textBox21.Text;
                CountySize++;
            }
            if (textBox22.Text.Length > 7)
            {
                county[CountySize] = textBox22.Text;
                CountySize++;
            }
            if (textBox23.Text.Length > 7)
            {
                county[CountySize] = textBox23.Text;
                CountySize++;
            }
            if (textBox24.Text.Length > 7)
            {
                county[CountySize] = textBox24.Text;
                CountySize++;
            }
            if (textBox25.Text.Length > 7)
            {
                county[CountySize] = textBox25.Text;
                CountySize++;
            }
            if (textBox26.Text.Length > 7)
            {
                county[CountySize] = textBox26.Text;
                CountySize++;
            }
            if (textBox27.Text.Length > 7)
            {
                county[CountySize] = textBox27.Text;
                CountySize++;
            }
            if (textBox28.Text.Length > 7)
            {
                county[CountySize] = textBox28.Text;
                CountySize++;
            }

            return CountySize;
        }
        delegate void AddTextCallback(string text);
        private void AddText(string text)
        {
            if (this.richTextBox1.InvokeRequired)
            {
                AddTextCallback d = new AddTextCallback(AddText);
                this.Invoke(d, new object[] { text });
            }
            else
            {
                this.richTextBox1.AppendText(text);
            }
        }
        delegate void AddGreenTextCallback(string text);
        private void AddGreenText(string text)
        {
            if (this.richTextBox1.InvokeRequired)
            {
                AddGreenTextCallback d = new AddGreenTextCallback(AddGreenText);
                this.Invoke(d, new object[] { text });
            }
            else
            {
                this.richTextBox1.SelectionColor = Color.Green;
                this.richTextBox1.AppendText(text);
            }
        }
        delegate void AddRedTextCallback(string text);
        private void AddRedText(string text)
        {
            if (this.richTextBox1.InvokeRequired)
            {
                AddRedTextCallback d = new AddRedTextCallback(AddRedText);
                this.Invoke(d, new object[] { text });
            }
            else
            {
                this.richTextBox1.SelectionColor = Color.Red;
                this.richTextBox1.AppendText(text);
            }
        }
        delegate void ReplaceTextCallback(string text);
        private void ReplaceText(string text)
        {
            if (this.richTextBox1.InvokeRequired)
            {
                ReplaceTextCallback d = new ReplaceTextCallback(ReplaceText);
                this.Invoke(d, new object[] { text });
            }
            else
            {
                this.richTextBox1.Clear();
                this.richTextBox1.AppendText(text);
            }
        }
        delegate void HideBCallback();
        private void HideB()
        {
            if (this.button7.InvokeRequired)
            {
                HideBCallback d = new HideBCallback(HideB);
                this.Invoke(d, new object[] {});
            }
            else
            {
                this.button7.Hide();
            }
        }
        delegate void ScanDelegate();
        private void button1_Click(object sender, EventArgs e) // start scan button
        {
            sem = true;
            button7.Show();
            button1.Hide();
            notifyIcon1.Text = "scanning...";
            ScanDelegate scanD = new ScanDelegate(Scan);
            scanD.BeginInvoke(null, null);
        }
        private void button2_Click(object sender, EventArgs e) // send to tray button
        {
            notifyIcon1.Visible = true;
            this.Hide();
        }
        private void button3_Click(object sender, EventArgs e) // save button
        {
            Save();
        }
        private void button4_Click(object sender, EventArgs e) // about button
        {
            richTextBox1.Clear();
            richTextBox1.AppendText("Version 1.3 " + (char)169 + "2011\n");
            richTextBox1.AppendText("visit http://www.kabuzol.net/ for\ndetailed instructions and more info.\n");
            richTextBox1.AppendText("\nthis program is not affiliated with http://craigslist.org/");
        }
        private void button5_Click(object sender, EventArgs e) // send test notification button
        {
            SendNotification("test alert successful");
        }
        private void button7_Click(object sender, EventArgs e) // stop scan button
        {
            sem = false;
            AddText("\n - scan stopped, wait for 'Start Scan' to reappear - \n");
            button1.Show();
            notifyIcon1.Text = "scan stopped";
        }
        public void Save()
        {
            if (File.Exists(path))
            {
                File.Delete(path);
            }
            // Create a file to write to.
            using (StreamWriter sw = File.CreateText(path)) // create the obj for this peroid of time
            {
                sw.WriteLine(textBox1.Text);
                sw.WriteLine(textBox2.Text);
                sw.WriteLine(textBox3.Text);
                sw.WriteLine(textBox4.Text);
                sw.WriteLine(textBox5.Text);
                sw.WriteLine(textBox6.Text);
                sw.WriteLine(textBox7.Text);
                sw.WriteLine(textBox8.Text);
                sw.WriteLine(textBox9.Text);
                sw.WriteLine(textBox10.Text);
                sw.WriteLine(textBox11.Text);
                sw.WriteLine(textBox12.Text);
                sw.WriteLine(textBox13.Text);
                sw.WriteLine(textBox14.Text);
                sw.WriteLine(textBox15.Text);
                sw.WriteLine(textBox16.Text);
                sw.WriteLine(textBox17.Text);
                sw.WriteLine(textBox18.Text);
                sw.WriteLine(textBox19.Text);
                sw.WriteLine(textBox20.Text);
                sw.WriteLine(textBox21.Text);
                sw.WriteLine(textBox22.Text);
                sw.WriteLine(textBox23.Text);
                sw.WriteLine(textBox24.Text);
                sw.WriteLine(textBox25.Text);
                sw.WriteLine(textBox26.Text);
                sw.WriteLine(textBox27.Text);
                sw.WriteLine(textBox28.Text);
                sw.WriteLine(textBox29.Text);
                sw.WriteLine(textBox30.Text);
                sw.WriteLine(textBox31.Text);
                sw.WriteLine(textBox32.Text);
                sw.WriteLine(textBox33.Text);
                string s = checkBox1.CheckState.ToString();
                sw.WriteLine(s);
                sw.WriteLine(comboBox1.Text);
            }
        }
        public void Loader()
        {
            if (File.Exists(path))
            {
                // Open the file to read from.
                using (StreamReader sr = File.OpenText(path)) // create the obj for this peroid of time
                {
                    string s = sr.ReadLine();
                    textBox1.Text = s;
                    s = sr.ReadLine();
                    textBox2.Text = s;
                    s = sr.ReadLine();
                    textBox3.Text = s;
                    s = sr.ReadLine();
                    textBox4.Text = s;
                    s = sr.ReadLine();
                    textBox5.Text = s;
                    s = sr.ReadLine();
                    textBox6.Text = s;
                    s = sr.ReadLine();
                    textBox7.Text = s;
                    s = sr.ReadLine();
                    textBox8.Text = s;
                    s = sr.ReadLine();
                    textBox9.Text = s;
                    s = sr.ReadLine();
                    textBox10.Text = s;
                    s = sr.ReadLine();
                    textBox11.Text = s;
                    s = sr.ReadLine();
                    textBox12.Text = s;
                    s = sr.ReadLine();
                    textBox13.Text = s;
                    s = sr.ReadLine();
                    textBox14.Text = s;
                    s = sr.ReadLine();
                    textBox15.Text = s;
                    s = sr.ReadLine();
                    textBox16.Text = s;
                    s = sr.ReadLine();
                    textBox17.Text = s;
                    s = sr.ReadLine();
                    textBox18.Text = s;
                    s = sr.ReadLine();
                    textBox19.Text = s;
                    s = sr.ReadLine();
                    textBox20.Text = s;
                    s = sr.ReadLine();
                    textBox21.Text = s;
                    s = sr.ReadLine();
                    textBox22.Text = s;
                    s = sr.ReadLine();
                    textBox23.Text = s;
                    s = sr.ReadLine();
                    textBox24.Text = s;
                    s = sr.ReadLine();
                    textBox25.Text = s;
                    s = sr.ReadLine();
                    textBox26.Text = s;
                    s = sr.ReadLine();
                    textBox27.Text = s;
                    s = sr.ReadLine();
                    textBox28.Text = s;
                    s = sr.ReadLine();
                    textBox29.Text = s;
                    s = sr.ReadLine();
                    textBox30.Text = s;
                    s = sr.ReadLine();
                    textBox31.Text = s;
                    s = sr.ReadLine();
                    textBox32.Text = s;
                    s = sr.ReadLine();
                    textBox33.Text = s;
                    s = sr.ReadLine();
                    if (s == "Checked")
                        checkBox1.CheckState = CheckState.Checked;
                    else
                        checkBox1.CheckState = CheckState.Unchecked;
                    s = sr.ReadLine();
                    comboBox1.Text = s;
                }
            }
        }
        private void notifyIcon1_DoubleClick(object sender, EventArgs e)
        {
            this.Show();
            notifyIcon1.Visible = false;
        }
        private void toolStripMenuItem1_Click(object sender, EventArgs e) // Exit Selection
        {
            this.Close();
        }
	    private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBox1.Text == "1 - 3")
                offSet = 0;
            if (comboBox1.Text == "2 - 4")
                offSet = 1;
            if (comboBox1.Text == "3 - 5")
                offSet = 2;
            if (comboBox1.Text == "4 - 6")
                offSet = 3;
            if (comboBox1.Text == "5 - 7")
                offSet = 4;
            if (comboBox1.Text == "6 - 8")
                offSet = 5;
            if (comboBox1.Text == "7 - 9")
                offSet = 6;
        }
    }
}
